#include <magic/applic.h>
#include "freenet.h"
#include "patternset.h"
#include "trainer.h"

Main () {
	assertmode = ASSERT_CRASH;
	
	readConfig ("backprop.cfg");

	ANNetwork* net = new ANNetwork;
	net->make (paramMap()["ANNetwork.topology"]);
	net->connectFullFfw (int(paramMap()["ANNetwork.shortcuts"]));
	
	//PatternSet set ("letters.dat", 35, 26);
	//PatternSet set ("xor.dat", 2, 1);
	PatternSet set ("proben1/heart/heart1.dt");
	PatternSet trainset, validset, traindata, testset;
	set.split (traindata, testset, 0.75);
	traindata.split (trainset, validset, 0.6667);
	printf ("Trainset=%d, validset=%d, testset=%d\n", trainset.patterns, validset.patterns, testset.patterns);
	
	Trainer* trainer;
	if (paramMap()["ANNetwork.trainer"] == "Backprop")
		trainer = new BackpropTrainer ();
	else
		trainer = new RPropTrainer ();
	
	trainer->setTerminator("GL5");
	trainer->init (paramMap()); 
	
	trainer->train (*net, trainset, int(paramMap()["maxCycles"]), &validset, 20);
	
	//for (int i=0; i<trainer->cyclesTrained(); i++)
	//	printf ("%d %f\n", i, trainer->trainingRecord()[i]);
	
	ClassifResults* clsTrain = net->testClassify (trainset);
	ClassifResults* clsValid = net->testClassify (validset);
	ClassifResults* clsTest  = net->testClassify (testset);
	printf ("%f\t%f", float(clsTrain->failures)/trainset.patterns*100, clsTrain->mse*100);
	printf ("\t%f\t%f", float(clsValid->failures)/validset.patterns*100, clsValid->mse*100);
	printf ("\t%f\t%f\n", float(clsTest->failures)/testset.patterns*100, clsTest->mse*100);
	delete clsTrain;
	delete clsValid;
	delete clsTest;
	
	delete trainer;
	
	fflush (stdout);
}


